/** written by olaf booij
 *  public domain */

#ifndef QRSMURRIE_CROSSOVER_HPP_INCLUDE
#define QRSMURRIE_CROSSOVER_HPP_INCLUDE

#include <cstdlib>
#include <cassert>
#include <algorithm>
#include <qrsmurrie/random_string.hpp>

namespace qrsmurrie {

  std::string crossover(std::string stringBeginToPasteEndIn, const std::string stringEnd)
  {
    assert(stringBeginToPasteEndIn.size() == stringEnd.size());
    unsigned crossoverIndex = std::rand() % (stringEnd.size() - 2) + 1; // some math added to not copy stringBegin or stringEnd 
    std::copy(stringEnd.begin() + crossoverIndex, stringEnd.end(), stringBeginToPasteEndIn.begin() + crossoverIndex);
    return(stringBeginToPasteEndIn);
  }
}

#endif // QRSMURRIE_CROSSOVER_HPP_INCLUDE

