/** written by olaf booij
 *  public domain */

#ifndef QRSMURRIE_MUTATE_HPP_INCLUDE
#define QRSMURRIE_MUTATE_HPP_INCLUDE

#include <cstdlib>
#include <cmath>
#include <qrsmurrie/random_string.hpp>

namespace qrsmurrie {

  std::string mutate(std::string stringToMutate)
  {
    unsigned mutationIndex = std::rand() % stringToMutate.size();
    stringToMutate.at(mutationIndex) = generate_random_char();
    return(stringToMutate);
  }

  std::string mutate(std::string stringToMutate, const double mutationChance)
  {
    if(mutationChance > (double) std::rand() / RAND_MAX)
      stringToMutate = mutate(stringToMutate);
    return(stringToMutate);
  }
}

#endif // QRSMURRIE_MUTATE_HPP_INCLUDE

