/** written by olaf booij
 *  public domain */

#ifndef QRSMURRIE_QRENCODE_WRAPPER_HPP_INCLUDE
#define QRSMURRIE_QRENCODE_WRAPPER_HPP_INCLUDE

#include <string>
#include <boost/shared_ptr.hpp>

namespace qrsmurrie {
  namespace qrencodelib {
#include <qrencode.h>
  }
  typedef boost::shared_ptr< qrencodelib::QRcode > QRcodePtr; 

  QRcodePtr encodeQR(const std::string text)
  {
    using namespace qrencodelib;
    QRcodePtr qrcode(QRcode_encodeString(text.c_str(), 0, QR_ECLEVEL_L, QR_MODE_8, 1), QRcode_free);
    if(qrcode == NULL) {
      std::cout << "./qrsmurrie/qrencode_wrapper.hpp: Failed to encode the input data" << std::endl;
    }
    return(qrcode);
  }

  template< typename QRcodeT > // = QRcode&
  bool getQRValue(const QRcodeT& qrcode, const unsigned index)
  {
    return(qrcode.data[index] % 2 == 1);
  }

  template< typename QRcodeT > // = QRcode&
  unsigned getNrOfQRValues(const QRcodeT& qrcode)
  {
    return(qrcode.width * qrcode.width);
  }
 
}

#endif // QRSMURRIE_QRENCODE_WRAPPER_HPP_INCLUDE

