/** written by olaf booij
 *  public domain */

#ifndef QRSMURRIE_RANDOM_TEXT_HPP_INCLUDE
#define QRSMURRIE_RANDOM_TEXT_HPP_INCLUDE

#include <string>
#include <cstdlib>
#include <algorithm>

namespace qrsmurrie {

  std::string get_possible_chars()
  {
    return("1234567890qwertyuiopasdfghjklzxcvbnmQWERTYUIOPASDFGHJKLZXCVBNM./~-_");
  }

  char generate_random_char()
  {
    static const std::string possible_chars = get_possible_chars();
    char random_char = possible_chars.at(std::rand() % possible_chars.size());
    return(random_char);
  }

  std::string generate_random_string(const unsigned size)
  {
    std::string random_string(size, ' ');
    std::generate(random_string.begin(), random_string.end(), generate_random_char);
    return(random_string);
  }
}

#endif // QRSMURRIE_RANDOM_TEXT_HPP_INCLUDE

