/** written by olaf booij
 *  public domain */

#include <iostream>
#include <string>
#include <cstdlib>
#include <ctime>
#include <qrsmurrie/qrencode_wrapper.hpp>
#include <qrsmurrie/random_string.hpp>
#include <qrsmurrie/image_compare.hpp>
#include <qrsmurrie/io.hpp>
#include <qrsmurrie/permSort.hpp>
#include <qrsmurrie/flok_of_strings.hpp>
#include <qrsmurrie/mutate.hpp>
#include <qrsmurrie/crossover.hpp>
//#include <boost/timer/timer.hpp>
#include <boost/progress.hpp>

using namespace qrsmurrie;
int main()
{
  using namespace std;
  srand(time(NULL));
  const unsigned stringSize = 10;
  MonoImage whiteImage = generateWhiteImage(getNrOfQRValuesGivenStringSize(stringSize));
  string best_string;
  const unsigned nr_of_strings = 100;
  Flok flok = randomFlok(nr_of_strings, stringSize);
  const unsigned nr_of_iterations = 1000;
  //boost::progress_display progressBar(nr_of_iterations);
  for(unsigned iter = 0; iter < nr_of_iterations; ++iter)
  {
    std::vector< unsigned > weaknesses;
    foreach(const std::string text, flok)
    {
      QRcodePtr qrcode = encodeQR(text);
      unsigned difference = differenceImageQR(whiteImage, *qrcode);
      weaknesses.push_back(difference);
      //cout << weaknesses.back() << endl;
    }
    //cout << endl;
    cout << weaknesses.at(0) << endl;
    std::vector< std::size_t > weaknessesPerm = permSort(weaknesses);
    flok = applyPerm2(weaknessesPerm, flok);
    for(unsigned replaceI = 0; replaceI < 10; ++replaceI)
      flok.at(flok.size() - replaceI - 1) = crossover(flok.at(replaceI), flok.at(replaceI+1));
    foreach(std::string& text, flok)
      text = mutate(text, .01);
    //++progressBar;
  }
  printQRcode(*encodeQR(flok.at(0)));
  std::cout << ">" << flok.at(0) << "<" << std::endl;
  return(0);
}
