/** written by olaf booij
 *  public domain */

#include <iostream>
#include <string>
#include <cstdlib>
#include <ctime>
#include <qrsmurrie/qrencode_wrapper.hpp>
#include <qrsmurrie/random_string.hpp>
#include <qrsmurrie/image_compare.hpp>
#include <qrsmurrie/io.hpp>
//#include <boost/timer/timer.hpp>
#include <boost/progress.hpp>

using namespace qrsmurrie;
int main()
{
  using namespace std;
  srand(time(NULL));
  const unsigned stringSize = 10;
  MonoImage whiteImage = generateWhiteImage(getNrOfQRValuesGivenStringSize(stringSize));
  string best_string;
  unsigned smallest_difference = whiteImage.size();
  unsigned nr_of_strings = 1000;
  boost::progress_display progressBar(nr_of_strings);
  for(unsigned stringI = 0; stringI < nr_of_strings; ++stringI)
  {
    std::string random_string = generate_random_string(stringSize);
    QRcodePtr qrcode = encodeQR(random_string);
    unsigned difference = differenceImageQR(whiteImage, *qrcode);
    if(difference < smallest_difference)
    {
      smallest_difference = difference;
      best_string = random_string;
    }
    ++progressBar;
  }
  printQRcode(*encodeQR(best_string));
  std::cout << ">" << best_string << "<" << std::endl;
  std::cout << "diffence is " << smallest_difference << std::endl;
  return(0);
}
